config/routes.rb
Rails.application.routes.draw do
  resources :plans
  resources :purchases
  resources :businesses do
    collection do
      get 'show_new'=>'businesses#show_new'
    end
    resources :categories
    resources :products
  end
  get 'home/index'
  get 'home1'=>'home#home_1'
  get 'new_products'=>'products#new_index'
  root 'home#index'
  devise_for :users, :controllers => {:registrations => "registrations"}
  resource :user, only: [:edit] do
	  collection do
	    patch 'update_password'
	  end
	end
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/category.rb
class Category < ApplicationRecord
    	
    validates :name, presence: { message: "Category name is required." }
    # validates :display_sequence, uniqueness: { message: "This display sequence is already taken." }

    belongs_to :business
    has_many :products
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: [:show, :edit, :update, :destroy]
  before_action :set_business
  # GET /categories
  # GET /categories.json
  def index
    @categories = @business.categories
  end

  # GET /categories/1
  # GET /categories/1.json
  def show
  end

  # GET /categories/new
  def new
    @category = Category.new
  end

  # GET /categories/1/edit
  def edit
  end

  # POST /categories
  # POST /categories.json
  def create
    @category = Category.new(category_params)
    @category.business_id = @business.id
    respond_to do |format|
      if @category.save
        format.html { redirect_to business_categories_path(@business), notice: 'Category was successfully created.' }
        format.json { render :show, status: :created, location: @category }
      else
        format.html { render :new }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1
  # PATCH/PUT /categories/1.json
  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to business_categories_path(@business), notice: 'Category was successfully updated.' }
        format.json { render :show, status: :ok, location: @category }
      else
        format.html { render :edit }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1
  # DELETE /categories/1.json
  def destroy
    @category.destroy
    respond_to do |format|
      format.html { redirect_to business_categories_path(@business), notice: 'Category was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def category_params
      params.require(:category).permit(:name, :display_sequence, :business_id)
    end

    def set_business
      @business = Business.find_by_id(params[:business_id])
    end
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/categories/_form.html.erb
<% if @category.errors.full_messages.any? %>
  <div class="row">
    <div class="col-lg-6 offset-lg-3 validation">
      <% @category.errors.messages.each do |error_message| %>
        <%= error_message.first.to_s.split('_').join(' ').titleize %> : <%= error_message[1].last %> <br />
      <% end %>    
    </div>
  </div>
<% end %>


<div class="row margin-top-50">
  <div class="col-lg-6 offset-lg-3">
      <div class="card">
          <div class="card-body">
              <h5 class="card-title">Add Category</h5>
              <hr>
              <%= form_for [business, category] do |form| %>
                  <div class="form-group">
                    <%= form.label :name %>
                    <%= form.text_field :name, id: :category_name , :class=>"form-control"%>
                  </div>
                  <div class="form-group">
                    <%= form.label :display_sequence %>
                    <%= form.number_field :display_sequence, id: :category_display_sequence, :class=>"form-control" %>
                  </div>
                  <hr>
                  <div class="form-actions m-t-40">
                    <button type="submit" class="btn btn-success"> <i class="fa fa-check"></i> Save</button>
                    <a type="button" class="btn btn-dark" href="<%= business_categories_path(current_user.business)%>">Cancel</a>
                  </div>
              <% end %>
          </div>
      </div>
  </div>
</div>

app/views/categories/edit.html.erb
<%= render 'form', category: @category, business: @business %>

app/views/categories/index.html.erb
<div class="row page-titles">
  <div class="col-md-5 align-self-center">
      <h4 class="text-themecolor">Categories</h4>
  </div>
  <div class="col-md-7 align-self-center text-right">
      <div class="d-flex justify-content-end align-items-center">
          <ol class="breadcrumb">
              <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
              <li class="breadcrumb-item active">Categories</li>
          </ol>
          <a type="button" class="btn btn-info d-none d-lg-block m-l-15" href="<%=new_business_category_path(current_user.business)%>"><i class="fa fa-plus-circle"></i> Create New</a>
      </div>
  </div>
</div>

<div class="row">
  <div class="col-lg-12">
    <div class="card">
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-striped table-bordered no-wrap" id="zero_config">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Display Sequence</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                      <% @categories.each do |category|%>
                        <tr>
                            <td><%= category.name%></td>
                            <td><%= category.display_sequence %></td>
                            <td><%= link_to 'Edit', edit_business_category_path(@business,category) %> <%= link_to 'Destroy', business_category_path(@business,category), method: :delete, data: { confirm: 'Are you sure?' } %></td>
                        </tr>
                      <% end %>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
</div>


<script>
        $(function(){
            $('#zero_config').DataTable();

        })
</script>

app/views/categories/new.html.erb
<%= render 'form', category: @category, business: @business %>